<template>
  <div>
    <div class="container">
      <div class="level">
        <div class="level-left">
          <p class="1">
            You are logged in as {{ user }}
          </p>
        </div>
        <!-- <div class="level-right">
          <b-button
            icon-left="logout-variant"
          >
            Log Out
          </b-button>
          <a
            :href="logOutUrl"
          > <b-icon icon="logout-variant" />Log Out</a>
        </div> -->
      </div>
    </div>
    <section class="section has-background-zerow-beige">
      <div
        class="container"
        style="min-height: 75vh"
      >
        <div class="columns">
          <div class="column is-four-fifths">
            <h1 class="is-size-2 title has-text-zerow-green-dark">
              Food Bank
            </h1>
          </div>
          <div class="column">
            <div class="image is-128x128">
              <img
                :src="foodbank"
                class="is-rounded filter-white"
              >
            </div>
          </div>
        </div>
        <div class="box">
          <h1 class="is-size-4 title has-text-zerow-green-dark">
            Juice offered by Mobile Press
          </h1>
          <b-table :data="juiceOfferings">
            <b-table-column
              v-slot="props"
              field="juiceOffering.juices[0].name"
              label="Name"
            >
              {{ props.row.juiceOffering.juices[0].name }}
            </b-table-column>
            <b-table-column
              v-slot="props"
              field="juice.quantity"
              label="Quantity"
            >
              {{ props.row.juiceOffering.juices[0].quantity }}
            </b-table-column>
            <b-table-column
              v-slot="props"
              field="juice.expiry_date"
              label="Expiry Date"
            >
              {{ props.row.juiceOffering.juices[0].expiry_date }}
            </b-table-column>
            <b-table-column
              v-slot="props"
              field="state"
              label="State"
            >
              {{ props.row.state }}
            </b-table-column>
            <template #empty>
              <div class="has-text-centered">
                No records
              </div>
            </template>
          </b-table>
        </div>
        <div class="box">
          <h1 class="is-size-4 title has-text-zerow-green-dark">
            Juice requested at Mobile Press
          </h1>
          <div class="block">
            <b-table :data="juiceRequests">
              <b-table-column
                v-slot="props"
                field="fruit.name"
                label="Name"
              >
                {{ props.row.juiceRequest.juices[0].name }}
              </b-table-column>
              <b-table-column
                v-slot="props"
                field="juice.quantity"
                label="Quantity"
              >
                {{ props.row.juiceRequest.juices[0].quantity }}
              </b-table-column>
              <b-table-column
                v-slot="props"
                field="state"
                label="State"
              >
                {{ props.row.state }}
              </b-table-column>
              <template #empty>
                <div class="has-text-centered">
                  No records
                </div>
              </template>
            </b-table>
          </div> <div class="block">
            <card-component title="Request juice at the Mobile Press">
              <form>
                <div class="columns">
                  <div class="column">
                    <b-field
                      horizontal
                      label="Name"
                    >
                      <b-input
                        v-model="juiceObj.juice.name"
                        placeholder="Name"
                        required
                      />
                    </b-field>
                  </div>
                  <div class="column">
                    <b-field
                      horizontal
                      label="Qty"
                    >
                      <b-input
                        v-model.number="juiceObj.juice.quantity"
                        placeholder="Quantity"
                        type="number"
                      />
                    </b-field>
                  </div>
                </div>
                <footer>
                  <b-button
                    class="button is-success"
                    :disabled="isDisabled"
                    @click="requestJuice"
                  >
                    Send
                  </b-button>
                </footer>
              </form>
            </card-component>
          </div>
        </div>
      </div>
    </section>
  </div>
</template>

<script>
import { defineComponent } from '@vue/composition-api'
import axios from 'axios'
import CardComponent from '@/components/CardComponent.vue'
import foodbank from '@/assets/food-donation.svg'
import { v4 as uuidv4 } from 'uuid'

export default defineComponent({
  name: 'Home',
  components: {
    CardComponent
  },
  data () {
    return {
      api: axios.create({
        baseURL: 'api/',
        timeout: 5000
      }),
      foodbank: foodbank,
      juiceRequests: [],
      juiceOfferings: [],
      fruitRequests: [],
      fruitObj: {
        id: '',
        fruit: {
          name: '',
          quantity: 0,
          price: 0.0,
          expiry_date: ''
        }

      },
      juiceObj: {
        id: '',
        juice: {
          name: '',
          quantity: 0,
          expiry_date: ''
        }

      },
      uuidv4: uuidv4,
      user: '',
      logOutUrl: '',
      titleStack: ['Admin', 'ZeroW']
    }
  },
  computed: {
    isDisabled () {
      return !this.juiceObj.juice.name || !this.juiceObj.juice.quantity
    }
  },
  created: async function () {
    await this.getUser()
    await this.fetchJuiceOfferings()
    await this.fetchJuiceRequests()
  },
  methods: {
    getUser: async function () {
      const resp = await this.api.get('/foodbank/user/')
      this.user = resp.data.user
      this.logOutUrl = resp.data.logOutUrl
    },
    fetchJuiceRequests: async function () {
      const resp = await this.api.get('/foodbank/juiceRequests/')
      this.juiceRequests = resp.data
    },
    fetchJuiceOfferings: async function () {
      const resp = await this.api.get('/foodbank/juiceOfferings/')
      this.juiceOfferings = resp.data
    },
    requestJuice: async function () {
      this.juiceObj.id = this.uuidv4()
      this.juiceObj.juice.expiry_date = '2023-07-01'
      const resp = await this.api.post('/foodbank/juiceRequests/',
        {
          id: this.juiceObj.id,
          juices: [
            this.juiceObj.juice
          ]
        }, {
          headers: {
            'content-type': 'application/json'
          }
        }

      )
      if (resp.status === 200) {
        await this.fetchJuiceRequests()
      }
    }
  }
})
</script>
